//************** THEME ****************
window.addEventListener( "click", function(event) {
    var modal = document.getElementById('themeModal');

    if (event.target == modal) {
        modal.style.display = "none";
    }
});

var themeList = [ ['red', 'Rouge', '#f44336'],
				  ['pink', 'Rose', '#e91e63'],
				  ['purple', 'Violet', '#9c27b0'],
				  ['indigo', 'Indigo', '#3f51b5'],
				  ['blue', 'Bleu', '#2196f3'],
				  ['light-blue', 'Bleu léger', '#87ceeb'],
				  ['cyan', 'Cyan', '#00bcd4'],
				  ['teal', 'Bleu sarcelle', '#009688'],
				  ['green', 'Vert', '#4caf50'],
				  ['light-green', 'Vert léger', '#8bc34a'],
				  ['lime', 'Vert citron', '#cddc39'],
				  ['khaki', 'Kaki', '#f0e68c'],
				  ['yellow', 'Jaune', '#ffeb3b'],
				  ['amber', 'Ambre', '#ffc107'],
				  ['orange', 'Orange', '#ff9800'],
				  ['blue-grey', 'Bleu gris', '#607d8b'],
				  ['dark-grey', 'Gris', '#616161']
				   ];

var ulElement = document.getElementById('theme-list');				   
for (i=0; i< themeList.length; i++) {
	var liElement = document.createElement('li');
	liElement.setAttribute('onclick', 'setTheme("'+themeList[i][0]+'");');
	liElement.setAttribute('style', 'overflow: hidden;')
	var colDiv = document.createElement('div');
	colDiv.setAttribute('style', 'float: left;width:30px; height:20px; margin-top:7px; background-color:'+themeList[i][2]);
	liElement.appendChild(colDiv);
	var textDiv = document.createElement('div');
	textDiv.setAttribute('style', 'float: left; margin-left:10px;');
	textDiv.innerHTML = themeList[i][1];
	liElement.appendChild(textDiv);
	ulElement.appendChild(liElement);
	
}	

function setTheme(color) {
	localStorage.setItem("theme", color);
	location.reload();
	
}			   
$('#themeChoose').on('click', function() {
	document.getElementById('themeModal').style.display='block';
});

var theme = 'teal';
if (typeof(Storage) !== "undefined") {
    var storedTheme = localStorage.getItem("theme");
	if (storedTheme != null) {
		theme = storedTheme;
	}
} 

$('<link rel="stylesheet" type="text/css" href="https://www.w3schools.com/lib/w3-theme-'+theme+'.css" >').appendTo("head");

//**************************************
// ******* DEFINITION DES MENUS : Titre -- icone -- sous-menus *****************

var mainMenus = [   ["Accueil", "maison-home63", ["Maison", "Séjour", "Chambre", "Etage"]], 
					["Lumières", "jeedom2-bulb14",["Résumé", "Salon", "Cuisine", "Chambre", "Palier"]], 
					["Sécurité", "jeedom-mouvement", []],
					["Chauffage", "fa-thermometer-three-quarters", []],
					["Audio", "fa-music", []]
					];


//***************************************************
// ********  CONSTRUCTION DES MENUS *****************

var flktyTop = [];
var flktyMain = [];
var menuFlkty;					

//main menu
var mainMenuDiv = document.getElementById("mainMenu");
for (var i = 0; i < mainMenus.length; i++) {	
	var divElement = document.createElement('div');
	divElement.setAttribute('class', "w3-icon-title");
	divElement.setAttribute('onclick', "");
    divElement.setAttribute('id', 'mainMenu'+i);
	
	var imgElement = document.createElement('span');
	imgElement.setAttribute('class', "fa "+mainMenus[i][1]+" fa-2x");
	divElement.appendChild(imgElement);
	
	var titleElement = document.createElement('div');
	titleElement.innerHTML = mainMenus[i][0];
	divElement.appendChild(titleElement);
	mainMenuDiv.appendChild(divElement);
	
}
$('#mainMenu0').addClass('w3-main-selected');
menuFlkty = new Flickity( mainMenuDiv, {
  // options
  pageDots: false, 
  prevNextButtons: false, 
  accessibility: true, 
  setGallerySize: false,
  cellAlign: 'left',
  contain: true,
  freeScroll: true
});

//main content
var mainContentDiv = document.getElementById("mainContent");
for (var i = 0; i < mainMenus.length; i++) {	
	var divElement = document.createElement('div');
	divElement.setAttribute('class', "gallery not-visible");
    divElement.setAttribute('id', 'mainContent'+i);
	mainContentDiv.appendChild(divElement);
	var flkty = new Flickity( divElement, {
      // options
      pageDots: false, 
      prevNextButtons: false, 
      accessibility: false, 
      setGallerySize: false,
      cellAlign: 'left',
	  dragThreshold: 15,
	  selectedAttraction: 0.01,
	  friction: 0.15
    });
	flktyMain.push(flkty);
	
	
}
activateContent("0");

//top menu
var topMenuDiv = document.getElementById("topMenu");
for (var i = 0; i < mainMenus.length; i++) {	
	var divElement = document.createElement('div');
	divElement.setAttribute('class', "w3-theme w3-scrollmenu");
    divElement.setAttribute('id', 'topMenu'+i);
	for (var j=0; j < mainMenus[i][2].length; j++) {
		var subElement = document.createElement('div');
		subElement.setAttribute('id', 'subMenu'+i+'-'+j);
		subElement.setAttribute('class', 'w3-top-item');
		subElement.innerHTML = (mainMenus[i][2][j]).toUpperCase();
		divElement.appendChild(subElement);		
	}
	if (mainMenus[i][2].length == 0) {
	  divElement.setAttribute('class', 'not-visible');
	}
	topMenuDiv.appendChild(divElement);
	
	var flkty = new Flickity( divElement, {
      // options
      pageDots: false, 
      prevNextButtons: false, 
      accessibility: true, 
      hash: true,
      setGallerySize: false,
      cellAlign: 'left',
      freeScroll: true,
	  contain: true,
	  asNavFor: document.getElementById("mainContent"+i)
    });
	flktyTop.push(flkty);
	

	
}
activateTopMenu("0");



//**************************************
// ********* FONCTIONS *****************

function activateTopMenu(id) {
    var menus = document.querySelectorAll('*[id^="topMenu"]');
    for (var i = 0; i < menus.length; i++) {
        if (menus[i].id == "topMenu"+id) {
			if (menus[i].hasChildNodes()) {
				menus[i].style.display='block';
			} else {
				menus[i].style.display='none';
			}
        } else if (menus[i].id != "topMenu") {
            menus[i].style.display='none';
        }
    } 
}

function activateContent(id) {
    var content = document.querySelectorAll('*[id^="mainContent"]');
    for (var i = 0; i < content.length; i++) {
        if (content[i].id == "mainContent"+id) {
           content[i].style.display='block';
        } else if (content[i].id != 'mainContent') {
            content[i].style.display='none';
        }
    } 
}


$('.w3-icon-title').on('click', function() {
            $(this).addClass('w3-main-selected').siblings().removeClass('w3-main-selected'); 
			var id = $(this).attr('id').replace('mainMenu', '');
			$('#main-title').text(mainMenus[id][0]);
			menuFlkty.select(id);
			activateTopMenu(id);
			activateContent(id);
			flktyTop[id].reloadCells();
			flktyMain[id].reloadCells();
			menuFlkty.reloadCells();			
			
        });  
$('.w3-top-item').on('click', function() {
			var mainId = menuFlkty.selectedIndex;
			var id = $(this).attr('id').replace('subMenu'+mainId+'-', '');
			flktyTop[mainId].select(id);			
        }); 


		


//********************************
//****** MAIN CONTENT ************

var eqList = [];

// Page vide
function emptyPage() {
	var divElement = document.createElement('div');
	divElement.setAttribute('class', "gallery-cell w3-frame");	

	return divElement;
}

// Ajoute un équipement
function addEq(div, id, html, params) {
	var divElement = document.createElement('div');
    divElement.setAttribute('id', id);

    $.ajax("core/img/design/html/"+html, {
      success: function(data) {        
        for (i=0; i < params.length; i++) {
			data = data.replace(new RegExp('#'+params[i][0]+'#', 'g'), params[i][1]);
			if (params[i][0] == 'id') { eqList.push(params[i][1]); }
		}  
        $('#'+id).html(data);
      }
    });	

	div.appendChild(divElement);
}

// Ajoute un espace vertical
function addSpace(div, pixel) {
	var divElement = document.createElement('div');
	divElement.setAttribute('style', "height:"+pixel+"px");
	div.appendChild(divElement);
}

//Ajoute une section
function addSection(div, title) {
	var divElement = document.createElement('div');
	divElement.setAttribute('style', "text-align:left; color:grey; padding-left:15px; padding-bottom:10px; padding-top:10px");
	divElement.innerHTML = title.toUpperCase();
	div.appendChild(divElement);
}

//************************************************
//************ DEFINITIONS DES CONTENUS **********

// ---------  Résumé  -------------

//Resumé
flktyMain[0].append( emptyPage() );

// Séjour
var frame = emptyPage();
addSpace(frame, 10);
addSection(frame, 'Luminosité');
addEq(frame, "luxSalon", "eq.light-sensor.html", [['title', 'Salon'], ['id', '1239']]);
addSpace(frame, 5);
addEq(frame, "luxSAM", "eq.light-sensor.html", [['title', 'Salle à manger'], ['id', '1257']]);
flktyMain[0].append( frame );

// Chambre
var frame = emptyPage();
addSpace(frame, 10);
addSection(frame, 'Luminosité');
addEq(frame, "luxChambre", "eq.light-sensor.html", [['title', 'Chambre'], ['id', '1927']]);
flktyMain[0].append( frame );

//Etage
var frame = emptyPage();
addSpace(frame, 10);
addSection(frame, 'Luminosité');
addEq(frame, "luxPal", "eq.light-sensor.html", [['title', 'Palier'], ['id', '2156']]);
flktyMain[0].append( frame );


// --------  Lumières  -------

//résumé
var frame = emptyPage();
addSpace(frame, 10);
addSection(frame, 'Groupes de lumières');
addEq(frame, "sejourLights", "eq.mix-light-group.html", [['title', 'Lumières du séjour'], ['id', '1841'], ['colorActionId', '1421'], ['colorOffActionId', '1175'],
              ['themeActionId', '1416'], ['dimActionId', '1358'], ['onActionId', '1158'], ['offActionId', '1157'], ['nbLights', '10'], ['nbWhiteLights', '4']]);
addSpace(frame, 5);
addEq(frame, "etageLights", "eq.mix-light-group.html", [['title', "Lumières à l'étage"], ['id', '1836'], ['colorActionId', '1475'], ['colorOffActionId', '1606'],
              ['themeActionId', '1474'], ['dimActionId', '1478'], ['onActionId', '1471'], ['offActionId', '1470'], ['nbLights', '4'], ['nbWhiteLights', '1']]);
flktyMain[1].append( frame );

//Salon
var frame = emptyPage();
addSpace(frame, 10);
addSection(frame, 'Groupe de lumières');
addEq(frame, "ambianceLights", "eq.mix-light-group.html", [['title', "Lumières d'ambiance"], ['id', '1838'], ['colorActionId', '1418'], ['colorOffActionId', '1175'],
              ['themeActionId', '1416'], ['dimActionId', '1355'], ['onActionId', '1194'], ['offActionId', '1193'], ['nbLights', '6'], ['nbWhiteLights', '2']]);

addSection(frame, 'Appareils');
addEq(frame, "hue", "eq.color-light.html", [['title', 'Hue salon'], ['id', '858'], ['colorInfoId', '857']]);
addSpace(frame, 5);
addEq(frame, "ledsSAM", "eq.color-light.html", [['title', 'Leds salle à manger'], ['id', '1571'], ['colorInfoId', '1573']]);
addSpace(frame, 5);
addEq(frame, "ledsTV", "eq.color-light.html", [['title', 'Leds TV'], ['id', '185'], ['colorInfoId', '1309']]);
addSpace(frame, 5);
addEq(frame, "bar", "eq.dim-light.html", [['title', 'Lumière salon'], ['id', '1181'], ['lightInfoId', '1184'], ['max-range', '99']]);
addSpace(frame, 5);
addEq(frame, "plafSAM", "eq.dim-light.html", [['title', 'Lumière salle à manger'], ['id', '1101'], ['lightInfoId', '1104'], ['max-range', '99']]);
addSpace(frame, 5);

flktyMain[1].append( frame );

//Cuisine
var frame = emptyPage();
addSpace(frame, 10);
addEq(frame, "plafCui", "eq.dim-light.html", [['title', 'Lumière cuisine'], ['id', '1188'], ['lightInfoId', '1191'], ['max-range', '99']]);
addSpace(frame, 5);
addEq(frame, "ledsC", "eq.color-light.html", [['title', 'Leds cuisine'], ['id', '1515'], ['colorInfoId', '1516']]);
flktyMain[1].append( frame );

//Chambre
var frame = emptyPage();
addSpace(frame, 10);
addEq(frame, "lampeCham", "eq.dim-light.html", [['title', 'Plafonnier'], ['id', '1260'], ['lightInfoId', '1263'], ['max-range', '99']]);
addSpace(frame, 5);
addEq(frame, "ledsCham", "eq.color-light.html", [['title', 'Leds couleur'], ['id', '1604'], ['colorInfoId', '1606']]);
addSpace(frame, 5);
addEq(frame, "hueB", "eq.dim-light.html", [['title', 'Lampe Steph'], ['id', '834'], ['lightInfoId', '831'], ['max-range', '255']]);
addSpace(frame, 5);
addEq(frame, "hueSAM", "eq.dim-light.html", [['title', 'Lampe Nanou'], ['id', '845'], ['lightInfoId', '842'], ['max-range', '255']]);
addSpace(frame, 5);
addEq(frame, "plafSdB", "eq.switch-light.html", [['title', 'Plafonnier Salle de bain'], ['id', '2132'], ['onId', '2128'], ['offId', '2130']]);
addSpace(frame, 5);
addEq(frame, "pmirSdB", "eq.switch-light.html", [['title', 'Miroir Salle de bain'], ['id', '2125'], ['onId', '2123'], ['offId', '2124']]);
addSpace(frame, 5);

flktyMain[1].append( frame );

//Palier
var frame = emptyPage();
addSpace(frame, 10);
addEq(frame, "lumEsc", "eq.dim-light.html", [['title', 'Lumière palier'], ['id', '1250'], ['lightInfoId', '1253'], ['max-range', '99']]);
addSpace(frame, 5);
addEq(frame, "lumPal", "eq.dim-light.html", [['title', 'Lumière escalier'], ['id', '1245'], ['lightInfoId', '1248'],['max-range', '255'] ]);
flktyMain[1].append( frame );



// ----------  Sécurité  ------------
var frame = emptyPage();
addSpace(frame, 10);
addSection(frame, 'Alarme');
addEq(frame, "alarm", "eq.alarm.html", [['title', 'Alarme maison'], ['id', '1295'], ['armId', '1302'], ['disarmId', '1303'], ['statusId', '1299'], ['immediateId', '1300']]);

addSection(frame, 'Capteurs de mouvements');
addEq(frame, "pirSalon", "eq.pir.html", [['title', 'Mouvement salon'], ['id', '1237']]);
addSpace(frame, 5);
addEq(frame, "pirEtage", "eq.pir.html", [['title', 'Mouvement salle à manger'], ['id', '1255']]);
addSpace(frame, 5);
addEq(frame, "pirSteph", "eq.pir.html", [['title', 'Mouvement chambre'], ['id', '1925']]);
addSpace(frame, 5);
addEq(frame, "pirPalier", "eq.pir.html", [['title', 'Mouvement palier'], ['id', '2155']]);

addSection(frame, 'Ouvertures');
addEq(frame, "doorMain", "eq.door.html", [['title', "Porte d'entrée"], ['id', '1242']]);

flktyMain[2].append( frame );


// ---------  Chauffage  ------------
var frame = emptyPage();
addSpace(frame, 10);
addSection(frame, 'Températures');
addEq(frame, "tempSalon", "eq.temp.html", [['title', 'Température salon'], ['id', '1238']]);
addSpace(frame, 5);
addEq(frame, "tempCh", "eq.temp.html", [['title', 'Température chambre'], ['id', '1926']]);
addSpace(frame, 5);
addEq(frame, "tempPalier", "eq.temp.html", [['title', 'Température étage'], ['id', '1256']]);

flktyMain[3].append( frame );

// ---------  Audio  ---------------
var frame = emptyPage();
addSpace(frame, 10);
addEq(frame, "ampSalon", "eq.ampli.html", [['title', 'Ampli Onkyo'], ['id', '968'], ['volInfoId', '974'], ['volActionId', '975'], ['max-range', '59'],
											['mutingInfoId', '971'], ['onActionId', '970'], ['offActionId', '969'], ['muteActionId', '973'], ['unmuteActionId', '972'],
											['sourceInfoId', '984'], ['sourceActions', '00,985|01,986|05,990|10,995'] ]);



addSpace(frame, 5);
addEq(frame, "musSalon", "eq.music.html", [ ['title', 'Musique salon'], ['id', '180'], ['HarmonyInfoId', '182'],
											['activePlayerId', '1843'], ['thumbnailInfoId', '1847'] ]);
											
flktyMain[4].append( frame );

//************************************************
//Refresh data

setTimeout(function(){ document.getElementById('mainMenu0').click(); }, 700);

function refreshData() {
	console.log('refresh data, nb eq='+eqList.length);
	for (i=0; i < eqList.length; i++) {
		
		var refreshFct = 'updateData'+eqList[i];
		console.log('call function '+refreshFct);
		window[refreshFct]();		
	}

}

$('#jeedomRefresh').on('click', function() {
	refreshData();
});
